net.minecraft.entity.passive

## Class EntityVillager

- java.lang.Object
- - net.minecraft.entity.Entity
  - - net.minecraft.entity.EntityLivingBase
    - - net.minecraft.entity.EntityLiving
      - - net.minecraft.entity.EntityCreature
        - - net.minecraft.entity.EntityAgeable
          - - net.minecraft.entity.passive.EntityVillager

- All Implemented Interfaces:
    IMerchant, INpc, IAnimals

      public class EntityVillager
      extends EntityAgeable
      implements IMerchant, INpc

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.minecraft.entity.Entity

      `Entity.EnumEntitySize`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.util.Map` | `blacksmithSellingList`
    `static java.util.Map` | `villagersSellingList`

    - ### Fields inherited from class net.minecraft.entity.EntityCreature

      `entityToAttack, field_110179_h, field_110181_i, fleeingTick, hasAttacked`

    - ### Fields inherited from class net.minecraft.entity.EntityLiving

      `defaultPitch, equipmentDropChances, experienceValue, livingSoundTime, numTicksToChaseTarget, targetTasks, tasks`

    - ### Fields inherited from class net.minecraft.entity.EntityLivingBase

      `arrowHitTimer, attackedAtYaw, attackingPlayer, attackTime, cameraPitch, dead, deathTime, entityAge, field_110154_aX, field_70741_aB, field_70763_ax, field_70764_aw, field_70768_au, field_70769_ao, field_70770_ap, hurtTime, isJumping, isSwingInProgress, jumpMovementFactor, lastDamage, limbSwing, limbSwingAmount, maxHurtResistantTime, maxHurtTime, moveForward, moveStrafing, newPosRotationIncrements, newPosX, newPosY, newPosZ, newRotationPitch, newRotationYaw, prevCameraPitch, prevHealth, prevLimbSwingAmount, prevRenderYawOffset, prevRotationYawHead, prevSwingProgress, randomYawVelocity, recentlyHit, renderYawOffset, rotationYawHead, scoreValue, swingProgress, swingProgressInt`

    - ### Fields inherited from class net.minecraft.entity.Entity

      `addedToChunk, boundingBox, capturedDrops, captureDrops, chunkCoordX, chunkCoordY, chunkCoordZ, dataWatcher, dimension, distanceWalkedModified, distanceWalkedOnStepModified, entityCollisionReduction, entityUniqueID, extendedProperties, fallDistance, field_70135_K, fireResistance, forceSpawn, height, hurtResistantTime, ignoreFrustumCheck, inPortal, inWater, isAirBorne, isCollided, isCollidedHorizontally, isCollidedVertically, isDead, isImmuneToFire, isInWeb, lastTickPosX, lastTickPosY, lastTickPosZ, motionX, motionY, motionZ, myEntitySize, noClip, onGround, portalCounter, posX, posY, posZ, prevDistanceWalkedModified, preventEntitySpawning, prevPosX, prevPosY, prevPosZ, prevRotationPitch, prevRotationYaw, rand, renderDistanceWeight, riddenByEntity, ridingEntity, rotationPitch, rotationYaw, serverPosX, serverPosY, serverPosZ, stepHeight, teleportDirection, ticksExisted, timeUntilPortal, velocityChanged, width, worldObj, yOffset, ySize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EntityVillager(World par1World)`
    `EntityVillager(World par1World, int par2)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `allowLeashing()`
    `protected void` | `applyEntityAttributes()`
    `protected boolean` | `canDespawn()`
    `EntityVillager` | `createChild(EntityAgeable par1EntityAgeable)`
    `protected void` | `entityInit()`
    `void` | `func_110297_a_(ItemStack par1ItemStack)`
    `static void` | `func_146089_b(MerchantRecipeList p_146089_0_, Item p_146089_1_, java.util.Random p_146089_2_, float p_146089_3_)`
    `static void` | `func_146091_a(MerchantRecipeList p_146091_0_, Item p_146091_1_, java.util.Random p_146091_2_, float p_146091_3_)`
    `EntityPlayer` | `getCustomer()`
    `protected java.lang.String` | `getDeathSound()`
    `protected java.lang.String` | `getHurtSound()`
    `protected java.lang.String` | `getLivingSound()`
    `int` | `getProfession()`
    `MerchantRecipeList` | `getRecipes(EntityPlayer par1EntityPlayer)`
    `void` | `handleHealthUpdate(byte par1)`
    `boolean` | `interact(EntityPlayer par1EntityPlayer)`
    `boolean` | `isAIEnabled()`
    `boolean` | `isMating()`
    `boolean` | `isPlaying()`
    `boolean` | `isTrading()`
    `void` | `onDeath(DamageSource par1DamageSource)`
    `IEntityLivingData` | `onSpawnWithEgg(IEntityLivingData par1EntityLivingData)`
    `void` | `readEntityFromNBT(NBTTagCompound par1NBTTagCompound)`
    `void` | `setCustomer(EntityPlayer par1EntityPlayer)`
    `void` | `setLookingForHome()`
    `void` | `setMating(boolean par1)`
    `void` | `setPlaying(boolean par1)`
    `void` | `setProfession(int par1)`
    `void` | `setRecipes(MerchantRecipeList par1MerchantRecipeList)`
    `void` | `setRevengeTarget(EntityLivingBase par1EntityLivingBase)`
    `protected void` | `updateAITick()`
    `void` | `useRecipe(MerchantRecipe par1MerchantRecipe)`
    `void` | `writeEntityToNBT(NBTTagCompound par1NBTTagCompound)`

    - ### Methods inherited from class net.minecraft.entity.EntityAgeable

      `addGrowth, getGrowingAge, isChild, onLivingUpdate, setGrowingAge, setScale, setScaleForAge, setSize`

    - ### Methods inherited from class net.minecraft.entity.EntityCreature

      `attackEntity, detachHome, findPlayerToAttack, func_110174_bM, func_142017_o, getBlockPathWeight, getCanSpawnHere, getEntityToAttack, getHomePosition, hasHome, hasPath, isMovementCeased, isWithinHomeDistance, isWithinHomeDistanceCurrentPosition, setHomeArea, setPathToEntity, setTarget, updateEntityActionState, updateLeashedState, updateWanderPath`

    - ### Methods inherited from class net.minecraft.entity.EntityLiving

      `addRandomArmor, canAttackClass, canBeSteered, canPickUpLoot, clearLeashed, despawnEntity, dropEquipment, dropFewItems, eatGrassBonus, enchantEquipment, faceEntity, func_110146_f, func_110163_bv, func_130225_q, getAlwaysRenderNameTag, getAlwaysRenderNameTagForRender, getArmorItemForSlot, getArmorPosition, getAttackTarget, getCommandSenderName, getCustomNameTag, getDropItem, getEntitySenses, getEquipmentInSlot, getExperiencePoints, getHeldItem, getJumpHelper, getLastActiveItems, getLeashed, getLeashedToEntity, getLookHelper, getMaxSafePointTries, getMaxSpawnedInChunk, getMoveHelper, getNavigator, getRenderSizeModifier, getTalkInterval, getVerticalFaceSpeed, hasCustomNameTag, interactFirst, isNoDespawnRequired, onEntityUpdate, onUpdate, playLivingSound, setAIMoveSpeed, setAlwaysRenderNameTag, setAttackTarget, setCanPickUpLoot, setCurrentItemOrArmor, setCustomNameTag, setEquipmentDropChance, setLeashedToEntity, setMoveForward, spawnExplosionParticle, updateAITasks`

    - ### Methods inherited from class net.minecraft.entity.EntityLivingBase

      `addPotionEffect, applyArmorCalculations, applyPotionDamageCalculations, attackEntityAsMob, attackEntityFrom, canBeCollidedWith, canBePushed, canBreatheUnderwater, canEntityBeSeen, clearActivePotions, collideWithEntity, collideWithNearbyEntities, curePotionEffects, damageArmor, damageEntity, decreaseAirSupply, dismountEntity, dropRareDrop, fall, func_110142_aN, func_142015_aE, func_146066_aG, func_146067_o, func_94060_bK, getAbsorptionAmount, getActivePotionEffect, getActivePotionEffects, getAge, getAIMoveSpeed, getAITarget, getArrowCountInEntity, getAttributeMap, getCreatureAttribute, getEntityAttribute, getEyeHeight, getHealth, getItemIcon, getLastAttacker, getLastAttackerTime, getLook, getLookVec, getMaxHealth, getPosition, getRNG, getRotationYawHead, getSoundPitch, getSoundVolume, getSwingProgress, getTeam, getTotalArmorValue, heal, isClientWorld, isEntityAlive, isEntityUndead, isMovementBlocked, isOnLadder, isOnSameTeam, isOnTeam, isPlayer, isPlayerSleeping, isPotionActive, isPotionActive, isPotionApplicable, jump, kill, knockBack, moveEntityWithHeading, onChangedPotionEffect, onDeathUpdate, onFinishedPotionEffect, onItemPickup, onNewPotionEffect, performHurtAnimation, rayTrace, removePotionEffect, removePotionEffectClient, renderBrokenItemStack, setAbsorptionAmount, setArrowCountInEntity, setBeenAttacked, setHealth, setJumping, setLastAttacker, setPositionAndRotation2, setPositionAndUpdate, setRotationYawHead, setSprinting, shouldRiderFaceForward, swingItem, updateArmSwingProgress, updateFallState, updatePotionEffects, updateRidden`

    - ### Methods inherited from class net.minecraft.entity.Entity

      `addEntityCrashInfo, addToPlayerScore, addVelocity, applyEntityCollision, canAttackWithItem, canRenderOnFire, canRiderInteract, canTriggerWalking, copyDataFrom, copyLocationAndAnglesFrom, dealFireDamage, doesEntityNotTriggerPressurePlate, dropItem, entityDropItem, equals, extinguish, func_145748_c_, func_145771_j, func_145772_a, func_145774_a, func_145775_I, func_145778_a, func_145780_a, func_145781_i, getAir, getBoundingBox, getBrightness, getBrightnessForRender, getCollisionBorderSize, getCollisionBox, getDataWatcher, getDistance, getDistanceSq, getDistanceSqToEntity, getDistanceToEntity, getEntityData, getEntityId, getEntityString, getExtendedProperties, getFlag, getMaxInPortalTime, getMountedYOffset, getParts, getPersistentID, getPickedResult, getPortalCooldown, getShadowSize, getSplashSound, getSwimSound, getTeleportDirection, getUniqueID, getYOffset, handleLavaMovement, handleWaterMovement, hashCode, hitByEntity, isBurning, isCreatureType, isEating, isEntityEqual, isEntityInsideOpaqueBlock, isEntityInvulnerable, isImmuneToFire, isInRangeToRender3d, isInRangeToRenderDist, isInsideOfMaterial, isInvisible, isInvisibleToPlayer, isInWater, isOffsetPositionInLiquid, isPushedByWater, isRiding, isSneaking, isSprinting, isWet, mountEntity, moveEntity, moveFlying, newDoubleNBTList, newFloatNBTList, onChunkLoad, onCollideWithPlayer, onKillEntity, onStruckByLightning, playSound, preparePlayerToSpawn, readFromNBT, registerExtendedProperties, resetEntityId, setAir, setAngles, setDead, setEating, setEntityId, setFire, setFlag, setInPortal, setInvisible, setInWeb, setLocationAndAngles, setOnFireFromLava, setPosition, setPositionAndRotation, setRotation, setSneaking, setVelocity, setWorld, shouldDismountInWater, shouldRenderInPass, shouldRiderSit, shouldSetPosAfterLoading, toString, travelToDimension, updateRiderPosition, writeMountToNBT, writeToNBT, writeToNBTOptional`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### villagersSellingList

          public static final java.util.Map villagersSellingList

    - #### blacksmithSellingList

          public static final java.util.Map blacksmithSellingList

  - ### Constructor Detail

    - #### EntityVillager

          public EntityVillager(World par1World)

    - #### EntityVillager

          public EntityVillager(World par1World,
                        int par2)

  - ### Method Detail

    - #### applyEntityAttributes

          protected void applyEntityAttributes()

      Overrides:
        `applyEntityAttributes` in class `EntityLiving`

    - #### isAIEnabled

          public boolean isAIEnabled()

      Overrides:
        `isAIEnabled` in class `EntityLiving`

    - #### updateAITick

          protected void updateAITick()

      Overrides:
        `updateAITick` in class `EntityLivingBase`

    - #### interact

          public boolean interact(EntityPlayer par1EntityPlayer)

      Overrides:
        `interact` in class `EntityAgeable`

    - #### entityInit

          protected void entityInit()

      Overrides:
        `entityInit` in class `EntityAgeable`

    - #### writeEntityToNBT

          public void writeEntityToNBT(NBTTagCompound par1NBTTagCompound)

      Overrides:
        `writeEntityToNBT` in class `EntityAgeable`

    - #### readEntityFromNBT

          public void readEntityFromNBT(NBTTagCompound par1NBTTagCompound)

      Overrides:
        `readEntityFromNBT` in class `EntityAgeable`

    - #### canDespawn

          protected boolean canDespawn()

      Overrides:
        `canDespawn` in class `EntityLiving`

    - #### getLivingSound

          protected java.lang.String getLivingSound()

      Overrides:
        `getLivingSound` in class `EntityLiving`

    - #### getHurtSound

          protected java.lang.String getHurtSound()

      Overrides:
        `getHurtSound` in class `EntityLivingBase`

    - #### getDeathSound

          protected java.lang.String getDeathSound()

      Overrides:
        `getDeathSound` in class `EntityLivingBase`

    - #### setProfession

          public void setProfession(int par1)

    - #### getProfession

          public int getProfession()

    - #### isMating

          public boolean isMating()

    - #### setMating

          public void setMating(boolean par1)

    - #### setPlaying

          public void setPlaying(boolean par1)

    - #### isPlaying

          public boolean isPlaying()

    - #### setRevengeTarget

          public void setRevengeTarget(EntityLivingBase par1EntityLivingBase)

      Overrides:
        `setRevengeTarget` in class `EntityLivingBase`

    - #### onDeath

          public void onDeath(DamageSource par1DamageSource)

      Overrides:
        `onDeath` in class `EntityLivingBase`

    - #### setCustomer

          public void setCustomer(EntityPlayer par1EntityPlayer)

      Specified by:
        `setCustomer` in interface `IMerchant`

    - #### getCustomer

          public EntityPlayer getCustomer()

      Specified by:
        `getCustomer` in interface `IMerchant`

    - #### isTrading

          public boolean isTrading()

    - #### useRecipe

          public void useRecipe(MerchantRecipe par1MerchantRecipe)

      Specified by:
        `useRecipe` in interface `IMerchant`

    - #### func_110297_a_

          public void func_110297_a_(ItemStack par1ItemStack)

      Specified by:
        `func_110297_a_` in interface `IMerchant`

    - #### getRecipes

          public MerchantRecipeList getRecipes(EntityPlayer par1EntityPlayer)

      Specified by:
        `getRecipes` in interface `IMerchant`

    - #### setRecipes

          public void setRecipes(MerchantRecipeList par1MerchantRecipeList)

      Specified by:
        `setRecipes` in interface `IMerchant`

    - #### func_146091_a

          public static void func_146091_a(MerchantRecipeList p_146091_0_,
                           Item p_146091_1_,
                           java.util.Random p_146091_2_,
                           float p_146091_3_)

    - #### func_146089_b

          public static void func_146089_b(MerchantRecipeList p_146089_0_,
                           Item p_146089_1_,
                           java.util.Random p_146089_2_,
                           float p_146089_3_)

    - #### handleHealthUpdate

          public void handleHealthUpdate(byte par1)

      Overrides:
        `handleHealthUpdate` in class `EntityLivingBase`

    - #### onSpawnWithEgg

          public IEntityLivingData onSpawnWithEgg(IEntityLivingData par1EntityLivingData)

      Overrides:
        `onSpawnWithEgg` in class `EntityLiving`

    - #### setLookingForHome

          public void setLookingForHome()

    - #### createChild

          public EntityVillager createChild(EntityAgeable par1EntityAgeable)

      Specified by:
        `createChild` in class `EntityAgeable`

    - #### allowLeashing

          public boolean allowLeashing()

      Overrides:
        `allowLeashing` in class `EntityLiving`